/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CarsFrame.java
 *
 * Created on May 16, 2011, 2:01:42 PM
 */
package cz.muni.fi.pv168.carsswingdemo;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author tomp
 */
public class CarsFrame extends javax.swing.JFrame {

    /** Creates new form CarsFrame */
    public CarsFrame() {
        initComponents();
        CarsTableModel model = (CarsTableModel)jTableCars.getModel();
        model.addCar(new Car(1, "Renault Clio", "2B6 7895", Color.RED, Fuel.GAS));
        model.addCar(new Car(2, "Škoda 120", "2A1 9999", Color.PINK, Fuel.LPG));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTableCars = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTableCars.setModel(new CarsTableModel());
        jScrollPane1.setViewportView(jTableCars);

        jButton1.setText("Add car");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(13, Short.MAX_VALUE)))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 156, Short.MAX_VALUE)
                    .addComponent(jButton1)
                    .addGap(0, 157, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(201, 201, 201)))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 137, Short.MAX_VALUE)
                    .addComponent(jButton1)
                    .addGap(0, 138, Short.MAX_VALUE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        CarsTableModel model = (CarsTableModel) jTableCars.getModel();
        model.addCar(randomCar());
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new CarsFrame().setVisible(true);
            }
        });
    }
    
    private Random random = new Random();
    private static final String[] CAR_TYPES = {"Škoda Felicia", "Škoda Octavia",
        "Ford Focus", "Ford Fiesta", "Renault Clio", "Porsche Carrera"};
    private static final Color[] CAR_COLORS = {Color.BLACK, Color.BLUE,
        Color.RED, Color.GREEN, Color.PINK, Color.WHITE, Color.YELLOW};

    private Car randomCar() {
        return new Car(
                random.nextInt(10000),
                CAR_TYPES[random.nextInt(CAR_TYPES.length)],
                "2C1 " + (random.nextInt(9000) + 1000),
                CAR_COLORS[random.nextInt(CAR_COLORS.length)],
                Fuel.values()[random.nextInt(Fuel.values().length)]);
    }

    private class CarsTableModel extends AbstractTableModel {

        private List<Car> cars = new ArrayList<Car>();

        @Override
        public int getRowCount() {
            return cars.size();
        }

        @Override
        public int getColumnCount() {
            return 5;
        }

        @Override
        public String getColumnName(int columnIndex) {
            switch (columnIndex) {
                case 0:
                    return "Id";
                case 1:
                    return "RegistrationNumber";
                case 2:
                    return "Type";
                case 3:
                    return "Color";
                case 4:
                    return "Fuel";
                default:
                    throw new IllegalArgumentException("columnIndex");
            }
        }

        @Override
        public Object getValueAt(int rowIndex, int columnIndex) {
            Car car = cars.get(rowIndex);
            switch (columnIndex) {
                case 0:
                    return car.getId();
                case 1:
                    return car.getRegistrationNumber();
                case 2:
                    return car.getType();
                case 3:
                    return car.getColor();
                case 4:
                    return car.getFuel();
                default:
                    throw new IllegalArgumentException("columnIndex");
            }
        }

        public void addCar(Car car) {
            cars.add(car);
            int lastRow = cars.size() - 1;
            fireTableRowsInserted(lastRow, lastRow);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableCars;
    // End of variables declaration//GEN-END:variables
}
